//
//  FYADMediation.h
//  FYADMediationDemo
//
//  Created by feiyu on 2021/11/4.
//

#import <Foundation/Foundation.h>
#import <FYADMediation/FYADMediationDelegate.h>
#import <FYADMediation/FYAMLoadBannerInfo.h>
#import <FYADMediation/FYAMInitInfo.h>
#import <FYADMediation/FYAMCallback.h>
#import <FYADMediation/FYAMInfo.h>


///
/// 10373
/// 2024.12.03
/// iOS广告聚合重构
/// 新增日志上报
/// build:1
///
/// 3.3.79
/// 2024.12.05
/// 对外发布
#define FYAMName @"FYADMediation"
#define FYAMVersion @"3.3.79"
#define FYAMInnerVersion @"10373"

extern NSString * const FYAMInitCallback;           // 初始化回调
extern NSString * const FYAMRewardCallback;         // 激励视频广告回调
extern NSString * const FYAMBannerCallback;         // Banner广告回调
extern NSString * const FYAMInterstitialCallback;   // 插屏广告回调

@interface FYADMediation : NSObject

/// 单例
+ (instancetype)sharedInstance;

/// 初始化
- (void)doInit:(FYAMInitInfo *)info;

/// 加载激励视频广告
- (void)loadReward:(FYAMInfo *)info;

/// 展示激励视频广告
- (void)showReward:(FYAMInfo *)info;

/// 激励视频广告是否已加载
- (NSString *)isRewardLoad:(FYAMInfo *)info;

/// 加载Banner广告
- (void)loadBanner:(FYAMLoadBannerInfo *)info;

/// 展示Banner广告
- (void)showBanner:(FYAMInfo *)info;

/// Banner广告是否已加载
- (NSString *)isBannerLoad:(FYAMInfo *)info;

/// 加载插屏广告
- (void)loadInterstitial:(FYAMInfo *)info;

/// 展示插屏广告
- (void)showInterstitial:(FYAMInfo *)info;

/// 插屏广告是否加载
- (NSString *)isInterstitialLoad:(FYAMInfo *)info;

- (NSString *)bridgeCallFunc:(NSString *)funcName infoJson:(NSString *)infoJson;

@end


//  3.3.29, 10059
//  feiyu
//  广告聚合一期
//
