//
//  FYADMediationDelegate.h
//  FYADMediationDemo
//
//  Created by feiyu on 2021/11/5.
//  Copyright © 2021 feiyu. All rights reserved.
//

#import <Foundation/Foundation.h>

@class FYAMLoadBannerInfo, FYAMInitInfo, FYAMCallback, FYAMInfo;



@protocol FYADMediationContainerDelegate <NSObject>

/// 初始化完成
- (void)initCompletion:(FYAMCallback *)response;

/// 观看 激励视频 广告完成
- (void)watchRewardCompletion:(FYAMCallback *)response;

/// 观看 banner 广告完成
- (void)watchBannerCompletion:(FYAMCallback *)response;

/// 观看 插屏 广告完成
- (void)watchInterstitialCompletion:(FYAMCallback *)response;


@end


@protocol FYADMediationDelegate <NSObject>
@required
- (void)setcDegelate:(id<FYADMediationContainerDelegate>)delegate;

/// 初始化
- (void)doInit:(FYAMInitInfo *)info;

/// 加载激励视频广告
- (void)loadReward:(NSString *)adId placementId:(NSString *)placementId;

/// 展示激励视频广告
- (void)showReward:(NSString *)adId placementId:(NSString *)placementId;

/// 激励视频广告是否已加载
- (NSString *)isRewardLoad:(NSString *)adId placementId:(NSString *)placementId;

/// 加载Banner广告
- (void)loadBanner:(FYAMLoadBannerInfo *)info adId:(NSString *)adId placementId:(NSString *)placementId;

/// 展示Banner广告
- (void)showBanner:(NSString *)adId placementId:(NSString *)placementId;

/// Banner广告是否已加载
- (NSString *)isBannerLoad:(NSString *)adId placementId:(NSString *)placementId;

/// 加载插屏广告
- (void)loadInterstitial:(NSString *)adId placementId:(NSString *)placementId;

/// 展示插屏广告
- (void)showInterstitial:(NSString *)adId placementId:(NSString *)placementId;

/// 插屏广告是否加载
- (NSString *)isInterstitialLoad:(NSString *)adId placementId:(NSString *)placementId;


@end

