package com.stars.bridge;
import com.unity3d.player.UnityPlayer;
import com.stars.combine.FYCombine;
import com.stars.antiaddiction.FYAntiAddiction;
import com.stars.antiaddiction.listener.FYAntiAddictionBridgeCallback;
import com.stars.service.FYService;
import com.stars.privacy.FYPrivacy;
import com.stars.admediation.FYADMediation;
public class FYSDKBridge {
    public static void FYSDKBridgeDoInit(String sdkName, String infoJson) {
        switch(sdkName){
			case "FYCombine":
				FYCombine.getInstance().bridgeDoInit(infoJson, new FYCombine.FYCombineBridgeCallback() {
					@Override
					public void callback(String callbackFunc, String callbackInfo) {
						UnityPlayer.UnitySendMessage("FYCombineBridgeCallback", callbackFunc, callbackInfo);
					}
				});
				break;
			case "FYAntiAddiction":
				FYAntiAddiction.getInstance().bridgeDoInit(infoJson, new FYAntiAddictionBridgeCallback() {
					@Override
					public void callback(String callbackFunc, String callbackInfo) {
						UnityPlayer.UnitySendMessage("FYAntiAddictionBridgeCallback", callbackFunc, callbackInfo);
					}
				});
				break;
			case "FYPrivacy":
				FYPrivacy.getInstance().bridgeDoInit(infoJson, new FYPrivacy.FYPrivacyBridgeCallback() {
					@Override
					public void callback(String callbackFunc, String callbackInfo) {
						UnityPlayer.UnitySendMessage("FYPrivacyBridgeCallback", callbackFunc, callbackInfo);
					}
				});
				break;
			case "FYADMediation":
				FYADMediation.getInstance().bridgeDoInit(infoJson, new FYADMediation.FYADMediationBridgeCallback() {
					@Override
					public void callback(String callbackFunc, String callbackInfo) {
						UnityPlayer.UnitySendMessage("FYADMediationBridgeCallback", callbackFunc, callbackInfo);
					}
				});
				break;
			default:
				break;
		}
    }
    public static String FYSDKBridgeCallFunc(String sdkName, String funcName, String infoJson) {
        String result = "";
		switch(sdkName){
			case "FYCombine":
				result = FYCombine.getInstance().bridgeCallFunc(funcName, infoJson);
				break;
			case "FYAntiAddiction":
				result = FYAntiAddiction.getInstance().bridgeCallFunc(funcName, infoJson);
				break;
			case "FYService":
				result = FYService.getInstance().bridgeCallFunc(funcName, infoJson);
				break;
			case "FYPrivacy":
				result = FYPrivacy.getInstance().bridgeCallFunc(funcName, infoJson);
				break;
			case "FYADMediation":
				result = FYADMediation.getInstance().bridgeCallFunc(funcName, infoJson);
				break;
			default:
				break;
		}
		return result;
    }
	public static boolean shouldShowRequestPermissionRationale(String permission){
		return UnityPlayer.currentActivity.shouldShowRequestPermissionRationale(permission);
	}
}
