#import "UnityAppController.h"
#import <FYCombine/FYCombine.h>
#import <FYAntiAddiction/FYAntiAddiction.h>
#import <FYPrivacy/FYPrivacy.h>
#import <FYADMediation/FYADMediation.h>
@interface FYSDKAppController : UnityAppController
@end
IMPL_APP_CONTROLLER_SUBCLASS (FYSDKAppController)
@implementation FYSDKAppController
- (BOOL)application:(UIApplication*)application didFinishLaunchingWithOptions:(NSDictionary*)launchOptions
{
    [super application:application didFinishLaunchingWithOptions:launchOptions];
    [[FYCombine sharedInstance] application:application didFinishLaunchingWithOptions:launchOptions];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fycombineInitCallback:) name:FYCOMBINE_CALLBACK_INIT object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fycombineLoginCallback:) name:FYCOMBINE_CALLBACK_LOGIN object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fycombinePayCallback:) name:FYCOMBINE_CALLBACK_PAY object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fycombineLogoutCallback:) name:FYCOMBINE_CALLBACK_LOGOUT object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fycombineRealNameCallback:) name:FYCOMBINE_CALLBACK_REAL_NAME object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fycombineQueryLocalProductsCallback:) name:FYCOMBINE_CALLBACK_QUERY_LOCAL_PRODUCTS object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fycombineBindCallback:) name:FYCOMBINE_CALLBACK_BIND object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fyanAntiAddictionCallback:) name:FYANAntiAddictionCallback object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fyanLimitPayCallback:) name:FYANLimitPayCallback object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fyanTimeOutCallback:) name:FYANTimeOutCallback object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fyanRealNameCallback:) name:FYANRealNameCallback object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fyprAuthCallback:) name:FYPRAuthCallback object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fyamInitCallback:) name:FYAMInitCallback object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(fyamRewardCallback:) name:FYAMRewardCallback object:nil];
    return YES;
}
- (void)applicationDidEnterBackground:(UIApplication *)application {
    [super applicationDidEnterBackground:application];
    [[FYCombine sharedInstance] applicationDidEnterBackground:application];
}
- (void)applicationWillEnterForeground:(UIApplication *)application {
    [super applicationWillEnterForeground:application];
    [[FYCombine sharedInstance] applicationWillEnterForeground:application];
}
- (void)applicationDidBecomeActive:(UIApplication *)application {
    [super applicationDidBecomeActive:application];
    [[FYCombine sharedInstance] applicationDidBecomeActive:application];
}
- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<UIApplicationOpenURLOptionsKey,id> *)options {
    [super application:app openURL:url options:options];
    [[FYCombine sharedInstance] application:app openURL:url options:options];
    return YES;
}
- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken {
    [super application:application didRegisterForRemoteNotificationsWithDeviceToken:deviceToken];
    [[FYCombine sharedInstance] application:application didRegisterForRemoteNotificationsWithDeviceToken:deviceToken];
}
- (BOOL)application:(UIApplication *)application continueUserActivity: (NSUserActivity*)userActivity restorationHandler: (void(^)(NSArray<id<UIUserActivityRestoring>> *__nullable restorableObjects))restorationHandler { 
    [super application:application continueUserActivity:userActivity restorationHandler:restorationHandler];
    [[FYCombine sharedInstance] application:application continueUserActivity:userActivity restorationHandler:restorationHandler];
    return YES;
}
- (void)fycombineInitCallback:(NSNotification*)notify {
    UnitySendMessage("FYCombineBridgeCallback", "FYCombineInitCallback", [notify.object toJSON].UTF8String);
}
- (void)fycombineLoginCallback:(NSNotification*)notify {
    UnitySendMessage("FYCombineBridgeCallback", "FYCombineLoginCallback", [notify.object toJSON].UTF8String);
}
- (void)fycombinePayCallback:(NSNotification*)notify {
    UnitySendMessage("FYCombineBridgeCallback", "FYCombinePayCallback", [notify.object toJSON].UTF8String);
}
- (void)fycombineLogoutCallback:(NSNotification*)notify {
    UnitySendMessage("FYCombineBridgeCallback", "FYCombineLogoutCallback", [notify.object toJSON].UTF8String);
}
- (void)fycombineRealNameCallback:(NSNotification*)notify {
    UnitySendMessage("FYCombineBridgeCallback", "FYCombineRealNameCallback", [notify.object toJSON].UTF8String);
}
- (void)fycombineQueryLocalProductsCallback:(NSNotification*)notify {
    UnitySendMessage("FYCombineBridgeCallback", "FYCombineQueryLocalProductsCallback", [notify.object toJSON].UTF8String);
}
- (void)fycombineBindCallback:(NSNotification*)notify {
    UnitySendMessage("FYCombineBridgeCallback", "FYCombineBindCallback", [notify.object toJSON].UTF8String);
}
- (void)fyanAntiAddictionCallback:(NSNotification*)notify {
    UnitySendMessage("FYAntiAddictionBridgeCallback", "FYANAntiAddictionCallback", [notify.object toJSON].UTF8String);
}
- (void)fyanLimitPayCallback:(NSNotification*)notify {
    UnitySendMessage("FYAntiAddictionBridgeCallback", "FYANLimitPayCallback", [notify.object toJSON].UTF8String);
}
- (void)fyanTimeOutCallback:(NSNotification*)notify {
    UnitySendMessage("FYAntiAddictionBridgeCallback", "FYANTimeOutCallback", [notify.object toJSON].UTF8String);
}
- (void)fyanRealNameCallback:(NSNotification*)notify {
    UnitySendMessage("FYAntiAddictionBridgeCallback", "FYANRealNameCallback", [notify.object toJSON].UTF8String);
}
- (void)fyprAuthCallback:(NSNotification*)notify {
    UnitySendMessage("FYPrivacyBridgeCallback", "FYPRAuthCallback", [notify.object toJSON].UTF8String);
}
- (void)fyamInitCallback:(NSNotification*)notify {
    UnitySendMessage("FYADMediationBridgeCallback", "FYAMInitCallback", [notify.object toJSON].UTF8String);
}
- (void)fyamRewardCallback:(NSNotification*)notify {
    UnitySendMessage("FYADMediationBridgeCallback", "FYAMRewardCallback", [notify.object toJSON].UTF8String);
}
@end
