using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;


public class GameController : MonoBehaviour
{
    private Text LogText;

    // Start is called before the first frame update
    void Start()
    {
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "DoUserCenter").onClick.AddListener(DoUserCenter);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "DoLogout").onClick.AddListener(DoLogout);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "DoPay").onClick.AddListener(DoPay);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "DoExitGame").onClick.AddListener(DoExitGame);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "CheckAuth").onClick.AddListener(CheckAuth);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "Service").onClick.AddListener(Service);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "CreateRole").onClick.AddListener(CreateRole);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "ShowReward").onClick.AddListener(ShowReward);
        this.LogText = FYUIHelper.FindChildGameObject<Text>(this.gameObject, "LogText");
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "PrintParams").onClick.AddListener(PrintParams);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "CleanLog").onClick.AddListener(CleanLog);

        SDKManager.Instance.QueryLocalProducts();

        SDKManager.Instance.LoadReward();
    }

    // Update is called once per frame
    void Update()
    {
        this.LogText.text = LogManager.Instance.Log;
    }

    private void DoUserCenter()
    {
        SDKManager.Instance.DoUserCenter();
    }

    private void DoLogout()
    {
        SDKManager.Instance.DoLogout();
    }

    private void DoPay()
    {
        SDKManager.Instance.DoPay();
    }

    private void DoExitGame()
    {
        SDKManager.Instance.DoExitGame();
    }

    private void CheckAuth()
    {
        SDKManager.Instance.CheckAuth();
    }

    private void Service()
    {
        SDKManager.Instance.ServiceAfterEnterGame();
    }

    private void CreateRole()
    {
        SDKManager.Instance.DoCollectInfo(FYCombine.CollectMethod.createRole);
        SDKManager.Instance.DoADTrackingReport("CREATE");
    }

    private void ShowReward()
    {
        SDKManager.Instance.ShowReward();
    }

    private void PrintParams()
    {
        LogManager.Instance.PrintParams();
    }

    private void CleanLog()
    {
        LogManager.Instance.Clean();
    }
}
