using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class LoginController : MonoBehaviour
{
    private Text LogText;

    // Start is called before the first frame update
    void Start()
    {
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "DoLogin").onClick.AddListener(DoLogin);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "DoSwitchAccount").onClick.AddListener(DoSwitchAccount);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "EnterGame").onClick.AddListener(EnterGame);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "Service").onClick.AddListener(Service);
        this.LogText = FYUIHelper.FindChildGameObject<Text>(this.gameObject, "LogText");
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "PrintParams").onClick.AddListener(PrintParams);
        FYUIHelper.FindChildGameObject<Button>(this.gameObject, "CleanLog").onClick.AddListener(CleanLog);

        if (!SDKManager.Instance.IsInitFinish)
        {
            SDKManager.Instance.DoInit();
        }   
    }

    // Update is called once per frame
    void Update()
    {
        this.LogText.text = LogManager.Instance.Log;
    }

    private void DoLogin()
    {
        if (!SDKManager.Instance.IsInitFinish)
        {
            LogManager.Instance.Add("###初始化未完成");
            return;
        }
        SDKManager.Instance.DoLogin();
    }

    private void DoSwitchAccount()
    {
        SDKManager.Instance.DoSwitchAccount();
    }

    private void EnterGame()
    {
        if (!SDKManager.Instance.IsLoginSuccess)
        {
            LogManager.Instance.Add("###登录未完成");
            return;
        }

        SDKManager.Instance.AntiAddiction();
    }

    private void Service()
    {
        if (SDKManager.Instance.IsLoginSuccess)
        {
            SDKManager.Instance.ServiceBeforeEnterGame();
        }
        else
        {
            SDKManager.Instance.ServiceBeforeLogin();
        }
    }

    private void PrintParams()
    {
        LogManager.Instance.PrintParams();
    }

    private void CleanLog()
    {
        LogManager.Instance.Clean();
    }
}
