﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using FYCombine;
using UnityEngine.SceneManagement;
using FYAntiAddiction;
using FYPrivacy;
using FYService;
using FYADMediation;
using System;

public class SDKManager 
{
    public static string GameVersion = "1.0.0";

    public bool IsInitFinish { get; private set; }

    public bool IsLoginSuccess { get; private set; }

    public string NebulaEnv { get; private set; }

    public string GoodsId { get; private set; }

    public string GoodsName { get; private set; }

    public string GameOrderId { get; private set; }

    public string PayAmount { get; private set; }

    public string AppId { get; private set; }

    public string ChannelId { get; private set; }

    public string ChannelTemplateId { get; private set; }

    public string ChannelTemplateCode { get; private set; }

    public string PassportCode { get; private set; }

    public string PaymentCode { get; private set; }

    public string DeviceId { get; private set; }

    public string ADTrackingData { get; private set; }

    public LoginSuccessInfo LoginSuccessInfo { get; private set; }

    public static string UserID = "user001";

    public static string UserName = "玩家001";

    public static string UserLevel = "1";

    public static string ServerID = "1";

    public static string ServerName = "区服001";

    public static string RegTime = "1724221316";

    public static string[] Goods = new string[] { "com.feiyu.mjt.libao1"};

    public static string[] ADS = new string[] { "reward_1" };

    private static SDKManager instance;

    public static SDKManager Instance
    {
        get
        {
            if (instance == null)
            {
                instance = new SDKManager();
            }
            return instance;
        }
    }

    private SDKManager()
    {

        AppId = FYCombineBridge.Instance.GetAppId();

        ChannelId = FYCombineBridge.Instance.GetChannelId();

        //ChannelTemplateId = FYCombineBridge.Instance.GetChannelTemplateId();

        //ChannelTemplateCode = FYCombineBridge.Instance.GetChannelTemplateCode();

        PassportCode = FYCombineBridge.Instance.GetPassportCode();

        PaymentCode = FYCombineBridge.Instance.GetPaymentCode();

        DeviceId = FYCombineBridge.Instance.GetDeviceId();

        FYCombineBridge.Instance.FYCombineInitCallback = (isSuccess) =>
        {
            // TODO: 初始化完成
            LogManager.Instance.Add("###初始化完成");
            IsInitFinish = true;

            ADTrackingData = FYCombineBridge.Instance.GetADTrackingData();
        };

        FYCombineBridge.Instance.FYCombineLoginCallback = new FYCombineLoginCallback((loginSuccessInfo) =>
        {
            //TODO: 登录成功
            //loginSuccessInfo.openId;        // 游戏维度唯一用户 ID;
            //loginSuccessInfo.token;        // 登录校验码，有效时间 1 小时，请在有效时间内完成校验，如超出时间需重新调用登录接口获取新校验码
            //loginSuccessInfo.userId;        // 第三方用户ID;
            //loginSuccessInfo.unionId;        // 全渠道唯一ID;
            //loginSuccessInfo.channelId;        // 渠道ID;
            //loginSuccessInfo.identityBirthday;        // 身份证生日;
            //loginSuccessInfo.identityAge;        // 身份证年龄;
            //loginSuccessInfo.paymentCode;        // 支付标识;
            //loginSuccessInfo.passportCode;        // 通行证标识;
            LogManager.Instance.Add($"###登录成功>>openId:{loginSuccessInfo.openId}");

            this.LoginSuccessInfo = loginSuccessInfo;
            this.IsLoginSuccess = true;

            // 接收防沉迷实名信息
            LogManager.Instance.Add($"###FYAntiAddictionBridge.Instance.RealName>>unionId:{this.LoginSuccessInfo.unionId}>>openId:{this.LoginSuccessInfo.openId}>>identityBirthday:{loginSuccessInfo.identityBirthday}>>identityAge:{loginSuccessInfo.identityAge}>>scene:1");

            FYAntiAddictionBridge.Instance.RealName(loginSuccessInfo.unionId, loginSuccessInfo.openId, loginSuccessInfo.identityBirthday, loginSuccessInfo.identityAge, "1");

        }, (commonInfo) =>
        {
            //TODO: 登录取消
            //需向用户提供再次登录的按钮，以便用户能重新登录
            LogManager.Instance.Add("###登录取消");
            IsLoginSuccess = false;
        }, (commonInfo) =>
        {
            //TODO: 登录失败，需向用户提供再次登录的按钮，以便用户能重新登录
            //commonInfo.message; // 失败原因
            LogManager.Instance.Add($"###登录失败>>{commonInfo.message}");
            IsLoginSuccess = false;
        });


        FYCombineBridge.Instance.FYCombinePayCallback = new FYCombinePayCallback((payInfo) =>
        {
            //TODO: 支付成功
            //payInfo.gameOrderId; // 游戏订单号
            //payInfo.orderId;// 星云订单号
            LogManager.Instance.Add($"###支付成功>>gameOrderId:{payInfo.gameOrderId}>>orderId:{payInfo.orderId}");
            //TODO:开始轮询奖励信息

            // 广告监测上报
            LogManager.Instance.Add($"###FYCombineBridge.Instance.DoADTrackingReport>>method:PAY");
            SDKModel.ADTrackingReportPay payModel = new SDKModel.ADTrackingReportPay();
            payModel.payAmount = int.Parse(PayAmount);
            string payJson = JsonUtility.ToJson(payModel);
            FYCombineBridge.Instance.DoADTrackingReport("PAY", payJson);
        }, (payInfo) =>
        {
            //TODO: 取消支付
            LogManager.Instance.Add("###取消支付");
        }, (payInfo) =>
        {
            //TODO: 支付失败
            //payInfo.message // 失败原因
            LogManager.Instance.Add($"###支付失败>>{payInfo.message}");
        }, (payInfo) =>
        {
            //TODO: 支付状态未知
            //第三方渠道没有给明确的客户端支付状态，建议游戏提示“等待中...”类似的不是很明确的提示
            //若后续有出"九游（UC）"这个渠道，请处理这个逻辑
            LogManager.Instance.Add("###支付状态未知");
        });

        FYCombineBridge.Instance.FYCombineExitGameCallback = (isExit) =>
        {
            if (isExit)
            {
                //游戏在此时直接关闭应用
                LogManager.Instance.Add("###直接关闭应用");
#if UNITY_EDITOR
                UnityEditor.EditorApplication.isPlaying = false;
#else
                Application.Quit();
#endif
            }
            else
            {
                LogManager.Instance.Add("###弹出自定义退出框");
                //游戏可以选择弹出自定义退出框
            }
        };

        FYCombineBridge.Instance.FYCombineLogoutCallback = (isLogout) =>
        {
            // TODO: 退出到登录首页
            LogManager.Instance.Add("###退出到登录首页");

            IsLoginSuccess = false;

            SceneManager.LoadScene(0);
        };


        FYCombineBridge.Instance.FYCombineRealNameCallback = new FYCombineRealNameCallback((realNameSuccessInfo) =>
        {
            //TODO: 认证成功
            //realNameSuccessInfo包含认证信息，游戏可以在此对用户进行奖励
            //realNameSuccessInfo.identityBirthday;//身份证生日
            //realNameSuccessInfo.identityAge;//身份证年龄
            LogManager.Instance.Add($"###认证成功>>identityBirthday:{realNameSuccessInfo.identityBirthday}>>identityAge:{realNameSuccessInfo.identityAge}");

            // 接收防沉迷实名信息
            LogManager.Instance.Add($"###FYAntiAddictionBridge.Instance.RealName>>unionId:{this.LoginSuccessInfo.unionId}>>openId:{this.LoginSuccessInfo.openId}>>identityBirthday:{realNameSuccessInfo.identityBirthday}>>identityAge:{realNameSuccessInfo.identityAge}>>scene:2");

            FYAntiAddictionBridge.Instance.RealName(this.LoginSuccessInfo.unionId, this.LoginSuccessInfo.openId, realNameSuccessInfo.identityBirthday, realNameSuccessInfo.identityAge, "2");
        }, (unRealNameInfo) =>
        {
            //TODO: 未实名游客时间
            //可以用来给游戏提示距离实名认证弹出还有多少时间。每隔10s会回调一次
            //unRealNameInfo.totalTime;//游客时间总时长，单位：秒
            //unRealNameInfo.remainTime;//游客剩余时长，单位：秒
        }, (commonInfo) =>
        {
            //TODO: 实名认证取消
            LogManager.Instance.Add($"###实名认证取消");
            
        }, (commonInfo) =>
        {
            //TODO: 实名认证失败
            //commonInfo.message; // 失败原因
            LogManager.Instance.Add($"###实名认证失败>>message:{commonInfo.message}");
            
        });

        FYCombineBridge.Instance.FYCombineQueryLocalProductsCallback = new FYCombineQueryLocalProductsCallback((localProductInfos) =>
        {
            //TODO: 获取本地化商品信息回调成功
            //localProductInfos.localProductInfos;//商品信息列表List<LocalProductInfo>
            LogManager.Instance.Add($"###获取本地化商品信息回调成功");
        }, (commonInfo) =>
        {
            //TODO: 获取本地化商品信息回调失败，请展示原始的商品信息
            //commonInfo.message; // 失败原因
            LogManager.Instance.Add($"###获取本地化商品信息回调失败>>message:{commonInfo.message}");
        });

        FYCombineBridge.Instance.FYCombineBindCallback = (isSuccess) =>
        {
            if (isSuccess)
            {
                //TODO: 绑定成功
                LogManager.Instance.Add($"###绑定成功");
            }
            else
            {
                //TODO: 绑定失败
                LogManager.Instance.Add($"###绑定失败");
                
            }
        };

        // 防沉迷弹窗回调
        FYAntiAddictionBridge.Instance.FYANAntiAddictionCallback = (isPass) =>
        {

            if (isPass)
            {
                //不符合防沉迷条件
                //可以正常进入游戏
                //可以继续进行游戏
                LogManager.Instance.Add("###不符合防沉迷条件，无需限制");
                // 上报数据
                DoCollectInfo(CollectMethod.enterServer);
                DoADTrackingReport("ENTER");

                // 跳转游戏内
                SceneManager.LoadScene(1);
            }
            else
            {
                //符合防沉迷条件，需要限制
                //禁止进入游戏
                //退回到登录首页
                LogManager.Instance.Add("###符合防沉迷条件，需要限制");
                DoLogout();
            }
        };

        // 是否到防沉迷时间回调
        FYAntiAddictionBridge.Instance.FYANTimeOutCallback = new FYANTimeOutCallback((timeOutInfo) => {
            //TODO: 到达防沉迷时间
            //timeOutInfo.totalTime;  // 总时间
            //timeOutInfo.remainTime;// 剩下时间
            LogManager.Instance.Add("###到达防沉迷时间");
            //游戏必须在此择机弹出防沉迷
            FYAntiAddictionBridge.Instance.AntiAddiction("2");
        }, (timeNotUpInfo) => {
            //TODO: 未到达防沉迷时间
            //timeNotUpInfo.totalTime;  // 总时间
            //timeNotUpInfo.remainTime;// 剩下时间
        });

        // 限制支付回调
        FYAntiAddictionBridge.Instance.FYANLimitPayCallback = new FYANLimitPayCallback((limitPayInfo) => {
            //TODO: 可以继续支付回调
            //此用户没有被限制支付，游戏可以继续支付
            //limitPayInfo.playerId;// 角色ID
            //limitPayInfo.serverId;// 区服ID
            //limitPayInfo.openId; // 唯一用户ID
            //limitPayInfo.amount;  // 金额（分）
            //limitPayInfo.extra;  // 额外参数
            LogManager.Instance.Add("###可以继续支付");

            string vipLevel = "0";
            string notifyExtra = "";
            string notifyURL = "";
            LogManager.Instance.Add($"###FYCombineBridge.Instance.DoPay>>UserID:{UserID}>>UserName:{UserName}>>UserLevel:{UserLevel}>>ServerID:{ServerID}>>ServerName:{ServerName}>>GoodsId:{GoodsId}>>GoodsName:{GoodsName}>>PayAmount:{PayAmount}>>GameOrderId:{GameOrderId}>>PaySignType:{PaySignType.md5}>>vipLevel:{vipLevel}>>notifyExtra:{notifyExtra}>>notifyURL:{notifyURL}");
            FYCombineBridge.Instance.DoPay(UserID, UserName, UserLevel, ServerID, ServerName, GoodsId, GoodsName, PayAmount, GameOrderId, PaySignType.md5, vipLevel, notifyExtra, notifyURL);
        }, (limitPayInfo) => {
            //TODO: 支付受限回调
            //此用户被限制支付，游戏需结束支付
            //limitPayInfo.playerId;// 角色ID
            //limitPayInfo.serverId;// 区服ID
            //limitPayInfo.openId; // 唯一用户ID
            //limitPayInfo.amount;  // 金额（分）
            //limitPayInfo.extra;  // 额外参数
            LogManager.Instance.Add($"###支付受限");
        });

        // 接收实名认证信息回调
        FYAntiAddictionBridge.Instance.FYANRealNameCallback = new FYANRealNameCallback((info) =>
        {
            // 表示设置实名认证信息已完成
            // 可以继续执行后续的防沉迷逻辑（防沉迷弹窗、充值限制等）
            LogManager.Instance.Add("###接收实名认证信息已完成");
        }, (info) =>
        {
            // 设置实名认证信息失败
            // 失败信息
            string msg = info.message;
            LogManager.Instance.Add($"###设置实名认证信息失败>>message:{msg}");
        });

        // 授权回调
        FYPrivacyBridge.Instance.FYPRAuthCallback = (isAgree, hasUsedChannelPrivacy) => {
            if (isAgree)
            {
                // 用户已同意授权
                // TODO: 执行其他 SDK 的初始化
                // hasUsedChannelPrivacy：标识是否使用了第三方渠道的协议。true：是，false：否。如果为false，则游戏需显示“查看隐私协议按钮”，否则不显示。
                // 游戏在母包阶段，需对此参数做处理。打成渠道包后，会根据实际情况返回相应的值。
                // 未接入星云聚合SDK的游戏，可以忽略此参数对接。
                LogManager.Instance.Add("###用户已同意授权");

                LogManager.Instance.Add($"###FYCombineBridge.Instance.DoInit>>GameVersion:{GameVersion}");

                FYCombineBridge.Instance.DoInit(GameVersion);

                LogManager.Instance.Add("###FYAntiAddictionBridge.Instance.DoInit");

                FYAntiAddictionBridge.Instance.DoInit();

                LogManager.Instance.Add("###FYServiceBridge.Instance.DoInit");

                FYServiceBridge.Instance.DoInit();

                LogManager.Instance.Add("###FYCombineBridge.Instance.DoADTrackingReport>>method:START");

                FYCombineBridge.Instance.DoADTrackingReport("START", "");

                LogManager.Instance.Add($"###FYADMediationBridge.Instance.DoInit>>GameVersion:{GameVersion}");

                FYADMediationBridge.Instance.DoInit(GameVersion);
            }
            else
            {
                // 用户不同意授权
                // TODO: 直接退出游戏
                LogManager.Instance.Add("###用户不同意授权");

#if UNITY_EDITOR
                UnityEditor.EditorApplication.isPlaying = false;
            #else
                Application.Quit();
            #endif
            }
        };

        FYADMediationBridge.Instance.FYAMInitCallback = new FYAMInitCallback((info) =>
        {
            //TODO: 初始化成功，可预加载广告
            //例如: FYADMediationBridge.Instance.LoadReward(placementId);
            LogManager.Instance.Add("###FYAMInitCallback>>初始化成功");

        }, (info) =>
        {
            //TODO: 初始化失败
            //info.message 失败原因
            LogManager.Instance.Add($"###FYAMInitCallback>>初始化失败>>info.message:{info.message}");
        });

        FYADMediationBridge.Instance.FYAMRewardCallback = new FYAMRewardCallback(info =>
        {
            //TODO: 下发奖励
            //info.placementId 获取游戏内展示位ID，用来对该展示位下发奖励
            LogManager.Instance.Add($"###FYAMRewardCallback>>下发奖励>>info.placementId:{info.placementId}");

            // 播放完成，下发奖励

        }, info =>
        {
            //TODO: 展示成功
            LogManager.Instance.Add($"###FYAMRewardCallback>>展示成功");
        }, info =>
        {
            //TODO: 展示失败
            //info.message 失败原因
            LogManager.Instance.Add($"###FYAMRewardCallback>>展示失败>>info.message:{info.message}");
        }, info =>
        {
            //TODO: 广告点击
            LogManager.Instance.Add($"###FYAMRewardCallback>>广告点击");
        }, info =>
        {
            //TODO: 广告关闭
            LogManager.Instance.Add($"###FYAMRewardCallback>>广告关闭");
        }, info =>
        {
            //TODO: 加载失败
            //info.message 失败原因
            LogManager.Instance.Add($"###FYAMRewardCallback>>加载失败>>info.message:{info.message}");
            // *禁止在此处调用加载广告接口，以防止游戏卡顿
        }, info =>
        {
            //TODO: 加载成功
            LogManager.Instance.Add($"###FYAMRewardCallback>>加载成功");
        });
    }

    public void DoInit()
    {
        LogManager.Instance.Add("###FYPrivacyBridge.Instance.Start");

        IList<string> protocolTitles = new List<string>();
        //key为系统权限类型，务必按照该接口的参数要求传递(小写字母)；value 权限友好说明，如“正常识别手机设备及账号安全”
        IDictionary<string, string> permissionInfos = new Dictionary<string, string>();
        permissionInfos.Add("phone", "读取手机设备信息权限");
        permissionInfos.Add("storage", "存储权限");
        permissionInfos.Add("location", "获取定位权限");
        FYPrivacyBridge.Instance.Start(protocolTitles, permissionInfos);
    }

    public void DoLogin()
    {
        LogManager.Instance.Add("###FYCombineBridge.Instance.DoLogin");

        FYCombineBridge.Instance.DoLogin();
    }

    public void DoSwitchAccount()
    {
        LogManager.Instance.Add("###FYCombineBridge.Instance.DoSwitchAccount");

        FYCombineBridge.Instance.DoSwitchAccount();
    }

    public void DoUserCenter()
    {
        LogManager.Instance.Add("###FYCombineBridge.Instance.DoUserCenter");

        FYCombineBridge.Instance.DoUserCenter(UserID, UserName, UserLevel, ServerID, ServerName);
    }

    public void DoLogout()
    {
        LogManager.Instance.Add("###FYCombineBridge.Instance.DoLogout");

        FYCombineBridge.Instance.DoLogout();
    }

    public void DoPay()
    {
        GoodsId = Goods[0];
        GoodsName = "100钻石";
        long gameOrderId = ((DateTimeOffset)DateTime.UtcNow).ToUnixTimeSeconds();
        GameOrderId = $"{gameOrderId}";
        PayAmount = "1";

        LogManager.Instance.Add($"###FYAntiAddictionBridge.Instance.LimitPay>>GoodsId:{GoodsId}>>GoodsName:{GoodsName}>>GameOrderId:{GameOrderId}>>PayAmount:{PayAmount}");

        FYAntiAddictionBridge.Instance.LimitPay(UserID, UserName, this.LoginSuccessInfo.openId, PayAmount, "");
    }

    public void DoExitGame()
    {
        LogManager.Instance.Add("###FYCombineBridge.Instance.DoExitGame");

        FYCombineBridge.Instance.DoExitGame();
    }

    public void DoCollectInfo(CollectMethod method)
    {
        LogManager.Instance.Add($"###FYCombineBridge.Instance.DoCollectInfo>>method:{method}");

        FYCombineBridge.Instance.DoCollectInfo(method, UserID, UserName, UserLevel, ServerID, ServerName, RegTime);
    }

    public void QueryLocalProducts()
    {
        LogManager.Instance.Add($"###FYCombineBridge.Instance.QueryLocalProducts");

        FYCombineBridge.Instance.QueryLocalProducts(Goods);
    }

    public void AntiAddiction()
    {
        LogManager.Instance.Add("###FYAntiAddictionBridge.Instance.AntiAddiction>>1");

        FYAntiAddictionBridge.Instance.AntiAddiction("1");
    }

    public void CheckAuth()
    {
        LogManager.Instance.Add("###FYPrivacyBridge.Instance.CheckAuth");

        FYPrivacyBridge.Instance.CheckAuth();
    }

    public void ServiceBeforeLogin()
    {
        LogManager.Instance.Add($"###FYServiceBridge.Instance.BeforeLogin>>GameVersion:{GameVersion}");

        FYServiceBridge.Instance.BeforeLogin(GameVersion);
    }

    public void ServiceBeforeEnterGame()
    {
        LogManager.Instance.Add($"###FYServiceBridge.Instance.BeforeEnterGame>>GameVersion:{GameVersion}>>openId:{this.LoginSuccessInfo.openId}");

        FYServiceBridge.Instance.BeforeEnterGame(GameVersion, this.LoginSuccessInfo.openId);
    }

    public void ServiceAfterEnterGame()
    {
        LogManager.Instance.Add($"###FYServiceBridge.Instance.AfterEnterGame>>GameVersion:{GameVersion}>>openId:{this.LoginSuccessInfo.openId}>>ServerID:{ServerID}>>ServerName:{ServerName}>>UserID:{UserID}>>UserName:{UserName}");

        FYServiceBridge.Instance.AfterEnterGame(GameVersion, this.LoginSuccessInfo.openId, ServerID, ServerName, UserID, UserName, "1", "1");
    }

    public void DoADTrackingReport(string method)
    {
        LogManager.Instance.Add($"###FYCombineBridge.Instance.DoADTrackingReport>>method:{method}");

        SDKModel.ADTrackingReportPlayer model = new SDKModel.ADTrackingReportPlayer();
        model.playerId = UserName;
        string json = JsonUtility.ToJson(model);
        FYCombineBridge.Instance.DoADTrackingReport(method, json);
    }

    public void LoadReward()
    {

        string placementId = ADS[0];
        LogManager.Instance.Add($"###FYADMediationBridge.Instance.LoadReward>>placementId:{placementId}");

        FYADMediationBridge.Instance.LoadReward(placementId);
    }

    public void ShowReward()
    {
        string placementId = ADS[0];
        bool isLoaded = FYADMediationBridge.Instance.IsRewardLoad(placementId);

        LogManager.Instance.Add($"###FYADMediationBridge.Instance.IsRewardLoad>>placementId:{placementId}>>isLoaded:{isLoaded}");

        if (isLoaded)
        {
            LogManager.Instance.Add($"###FYADMediationBridge.Instance.ShowReward>>placementId:{placementId}");

            // 加载成功，展示广告
            FYADMediationBridge.Instance.ShowReward(placementId);
        }
        else
        {
            LogManager.Instance.Add($"###FYADMediationBridge.Instance.LoadReward>>placementId:{placementId}");

            // 加载失败，再次加载广告
            FYADMediationBridge.Instance.LoadReward(placementId);
        }
    }
}
